Attribute VB_Name = "GetDelay"
Option Explicit

Private Const REG_DWORD = 4 'Long integer
Private Const HKEY_LOCAL_MACHINE = &H80000002 'HKEY_LOCAL_MACHINE

'API Declarations
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Private Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String) As String
  Dim lResult As Long
  Dim lValueType As Long
  Dim lDataBufSize As Long
  Dim DWORDData As Integer
  'retrieve nformation about the key
  lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
  If lResult = 0 Then
    If lValueType = REG_DWORD Then
      'retrieve the key's value
      lResult = RegQueryValueEx(hKey, strValueName, 0, 0, DWORDData, lDataBufSize)
      If lResult = 0 Then
        RegQueryStringValue = DWORDData
      End If
    End If
  End If
End Function
Private Function GetString(hKey As Long, strPath As String, strValue As String)
  Dim Ret
  'Open the key
  RegOpenKey hKey, strPath, Ret
  'Get the key's content
  GetString = RegQueryStringValue(Ret, strValue)
  'Close the key
  RegCloseKey Ret
End Function
'Get the speed of the CPU in MHz
Private Function GetCPUSpeedMHz() As Long
  Dim Temp As Long
  Temp = CLng(GetString(HKEY_LOCAL_MACHINE, "HARDWARE\DESCRIPTION\System\CentralProcessor\0", "~MHz"))
  If Temp = 0 Then Temp = 1000
  GetCPUSpeedMHz = Temp
End Function
'Get the delay time
'It is ~ 1msec to count from 0 to value returned by this function
Public Function GetDelayTime() As Long
  GetDelayTime = GetCPUSpeedMHz * 10
End Function
